<template>
  <div id="SignTable">
    <v-data-table
      flat
      :headers="headers"
      :items="itens_props"
      item-key="id"
      hide-default-footer
      :no-data-text="$t('global.mensager.no_itens')"
      :loading="loading_props"
      :page.sync="page_props"
      :items-per-page="per_page_props"
    >
      <!-- Register -->
      <template v-slot:item.created_at="{ item }">
        <span class="system_grey_2--text body-2-signbank">
          {{ dateCurrentLanguageMixin(item.created_at) }}
        </span>
      </template>

      <!-- Lemma -->
      <template v-slot:item.lema="{ item }">
        <span class="system_grey_2--text body-2-signbank">
          {{ setCurrentLanguageMixin(item.lema, item.traducao, "lema") }}
        </span>
      </template>

      <!-- Gloss ID -->
      <template v-slot:item.id="{ item }">
        <span class="system_grey_2--text body-2-signbank">
          {{ setCurrentLanguageMixin(item.glosa, item.traducao, "glosa") }}
        </span>
      </template>

      <!-- Image -->
      <template v-slot:item.image="{ item }">
        <div class="d-flex flex-column align-center my-2">
          <div class="my-2 system_grey_3">
            <v-img
              v-if="item.imagem"
              width="100%"
              max-width="60"
              alt="Imagem de exemplo"
              :src="item.imagem.url ? item.imagem.url : ''"
            ></v-img>
            <v-icon class="my-3 mx-5" v-if="!item.imagem"> mdi-image </v-icon>
          </div>
        </div>
      </template>

      <!-- Video -->
      <template v-slot:item.video="{ item }">
        <div class="d-flex flex-column align-center my-2">
          <div class="my-2 system_grey_3">
            <template v-if="item.video">
              <v-img
                width="100%"
                max-width="85"
                :src="item.video.thumb ? item.video.thumb : ''"
              >
                <div class="d-flex align-center justify-center">
                  <v-btn
                    x-small
                    fab
                    dark
                    small
                    color="primary"
                    style="z-index: 999"
                    @click="controlDialogVideo(item.video)"
                    class="cursor-pointer"
                  >
                    <v-icon color="white"> mdi-play </v-icon>
                  </v-btn>
                </div>
              </v-img>
            </template>

            <v-icon class="my-3 mx-8" v-if="!item.video"> mdi-video </v-icon>
          </div>
        </div>
      </template>

      <!-- Translation -->
      <template v-slot:item.translate="{ item }">
        <div class="my-2">
          <p class="system_grey_2--text body-2-signbank mb-0">
            <span v-if="selected_item === item.lema">
              {{
                setLanguageSelectedMixin(
                  item.lema,
                  item.traducao,
                  "lema",
                  selected_language
                )
              }}
            </span>
            <span v-if="selected_item !== item.lema">
              {{ setCurrentLanguageMixin(item.lema, item.traducao, "lema") }}
            </span>
          </p>

          <v-menu bottom offset-y min-width="125px" open-on-hover>
            <template v-slot:activator="{ on, attrs }">
              <v-btn v-bind="attrs" v-on="on" text>
                <span
                  class="body-2-signbank text-uppercase family-openSans-semi-bold text-capitalize info--text"
                  v-if="!selected_language"
                >
                  {{ $nuxt._i18n.locale }}
                </span>
                <template v-if="selected_language">
                  <span
                    v-if="selected_item === item.lema"
                    class="body-2-signbank text-uppercase family-openSans-semi-bold text-capitalize info--text"
                  >
                    {{ selected_language }}
                  </span>
                  <span
                    v-if="selected_item !== item.lema"
                    class="body-2-signbank text-uppercase family-openSans-semi-bold text-capitalize info--text"
                  >
                    {{ $nuxt._i18n.locale }}
                  </span>
                </template>

                <v-icon class="info--text"> mdi-chevron-down </v-icon>
              </v-btn>
            </template>

            <v-list>
              <v-list-item
                v-for="(languageItem, index) in $nuxt._i18n.locales"
                :key="index"
                class="cursor-pointer"
              >
                <v-list-item-content>
                  <v-list-item-title
                    class="d-flex align-center"
                    @click="selectLanguage(languageItem.iso, item.lema)"
                  >
                    <span
                      class="caption-signbank text-uppercase family-openSans-semi-bold info_dark--text"
                    >
                      {{ languageItem.iso }}
                    </span>
                  </v-list-item-title>
                </v-list-item-content>
              </v-list-item>
            </v-list>
          </v-menu>
        </div>
      </template>

      <!-- Approver -->
      <template v-slot:item.published_by="{ item }">
        <div class="d-flex align-center my-2" v-if="item.status">
          <template v-if="item.aprovador">
            <UserAvatar :user_props="item.aprovador" />

            <span class="system_grey_2--text body-2-signbank">
              {{ item.aprovador.nome ? item.aprovador.nome : "" }}
            </span>
          </template>

          <template v-if="!item.aprovador">
            {{ $t("global.mensager.approver_not_informed") }}
          </template>
        </div>

        <div class="d-flex align-center my-2" v-if="!item.status">
          <span class="system_grey_2--text body-2-signbank">
            {{ $t("global.mensager.not_approved") }}
          </span>
        </div>
      </template>

      <!-- Status -->
      <template v-slot:item.status="{ item }">
        <v-chip
          small
          label
          class="pa-4"
          outlined
          :color="'system_grey_2'"
          v-if="!item.status"
        >
          <v-icon left dark class="mr-1">
            {{ "mdi-hand-back-left-off-outline" }}
          </v-icon>

          <span class="caption-signbank family-openSans-semi-bold">
            {{ $t("signs.status.pending") }}
          </span>
        </v-chip>

        <v-chip
          small
          label
          class="pa-4"
          outlined
          :color="'success'"
          v-if="item.status"
        >
          <v-icon left dark class="mr-1">
            {{ "mdi-hand-back-left-outline" }}
          </v-icon>

          <span class="caption-signbank family-openSans-semi-bold">
            {{ $t("signs.status.aproved") }}
          </span>
        </v-chip>
      </template>

      <!-- Action -->
      <template v-slot:item.actions="{ item }">
        <template class="py-5" justify="center">
          <!-- Sync-->
          <v-tooltip max-width="200px" bottom>
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                icon
                small
                color="info"
                :to="
                  localePath(
                    '/dashboard/signs/edit/' + item.slug,
                    $nuxt._i18n.locale
                  )
                "
                v-bind="attrs"
                v-on="on"
              >
                <v-icon small>mdi-sync</v-icon>
              </v-btn>
            </template>
            <span>
              {{ $t("buttons.edit") }}
            </span>
          </v-tooltip>
        </template>
      </template>
    </v-data-table>

    <!-- Footer/Pagination -->
    <slot name="footer"> </slot>

    <!-- Dialog Video-->
    <v-dialog v-if="dialogs.video" max-width="800px" v-model="dialogs.video">
      <v-card>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn icon color="system_grey_3" @click="controlDialogVideo()">
            <v-icon>mdi-close</v-icon>
          </v-btn>
        </v-card-actions>
        <v-card-text v-if="selected_video">
          <VideoPlayerUtils :video_props="selected_video.video" />
        </v-card-text>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import VideoPlayerUtils from "@/components/Utils/Videos/PlayerVideosUtils.vue";
import FormatDataMixin from "@/mixins/Global/FormatData.vue";
import TranslateMixin from "@/mixins/Global/TranslateMixin.vue";
import UserAvatar from "@/components/Avatar/User/UserAvatar.vue";

export default {
  props: ["loading_props", "itens_props", "page_props", "per_page_props"],
  mixins: [FormatDataMixin, TranslateMixin],

  components: {
    VideoPlayerUtils,
    UserAvatar,
  },

  data() {
    return {
      selected_video: null,

      selected_language: "",
      selected_item: "",

      dialogs: {
        video: false,
      },
      headers: [
        {
          text: this.$t("global.register"),
          value: "created_at",
          sortable: false,
          width: 80,
        },

        {
          text: this.$t("signs.lemma"),
          value: "lema",
          sortable: false,
          width: 90,
        },

        {
          text: this.$t("signs.gloss_id"),
          value: "id",
          sortable: false,
          width: 90,
        },

        {
          text: this.$t("global.image"),
          value: "image",
          sortable: false,
          width: 50,
        },

        {
          text: this.$t("global.video"),
          value: "video",
          sortable: false,
          width: 50,
        },

        {
          text: this.$t("global.translate"),
          value: "translate",
          sortable: false,
          width: 90,
        },

        {
          text: this.$t("global.approver"),
          value: "published_by",
          sortable: false,
          width: 140,
        },

        {
          text: this.$t("global.status.title"),
          value: "status",
          sortable: false,
          width: 65,
        },

        {
          text: "",
          value: "actions",
          sortable: false,
          width: 85,
        },
      ],
    };
  },

  methods: {
    selectLanguage(code_language, item_selected) {
      this.selected_language = code_language;
      this.selected_item = item_selected;
    },

    controlDialogVideo(video) {
      if (video) {
        this.selected_video = video;
      }
      this.dialogs.video = !this.dialogs.video;
    },
  },
};
</script>

<style>
#SignTable .video-player-signs-container {
  width: 63px;
  height: 58px;
  position: relative;
}

#SignTable .content-to-open-modal {
  height: 58px;
  width: 63px;
  position: absolute;
  z-index: 99999;
}

#SignTable .v-data-table-header th {
  color: #868e96 !important;
  text-transform: uppercase;
}

#SignTable .v-data-table tbody {
  color: var(--system-grey-1) !important;
  font-size: var(--size-body-2) !important;
}

#SignTable .sign-image {
  width: 63px;
  height: 58px;
}

#SignTable .hand-sign-image {
  height: 32px;
  width: 32px;
}

#SignTable .aproved-by-image {
  height: 29px;
  width: 29px;
}

@media (max-width: 768px) {
  #SignTable .sign-image {
    width: 58px;
    height: 58px;
  }

  #SignTable .aproved-by-image {
    height: 42px;
    width: 62px;
  }
}

@media (max-width: 320px) {
  #SignTable .sign-image {
    width: 53px;
    height: 58px;
  }
}
</style>
